# Rust API client for oneof-reqwest

This tests for a oneOf interface representation



## Overview

This API client was generated by the [OpenAPI Generator](https://openapi-generator.tech) project.  By using the [openapi-spec](https://openapis.org) from a remote server, you can easily generate an API client.

- API version: 0.0.1
- Package version: 0.0.1
- Generator version: 7.8.0-SNAPSHOT
- Build package: `org.openapitools.codegen.languages.RustClientCodegen`

## Installation

Put the package under your project folder in a directory named `oneof-reqwest` and add the following to `Cargo.toml` under `[dependencies]`:

```
oneof-reqwest = { path = "./oneof-reqwest" }
```

## Documentation for API Endpoints

All URIs are relative to *http://localhost:8080*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*BarApi* | [**create_bar**](docs/BarApi.md#create_bar) | **POST** /bar | Create a Bar
*FooApi* | [**create_foo**](docs/FooApi.md#create_foo) | **POST** /foo | Create a Foo
*FooApi* | [**get_all_foos**](docs/FooApi.md#get_all_foos) | **GET** /foo | GET all Foos


## Documentation For Models

 - [Addressable](docs/Addressable.md)
 - [Apple](docs/Apple.md)
 - [Banana](docs/Banana.md)
 - [Bar](docs/Bar.md)
 - [BarCreate](docs/BarCreate.md)
 - [BarRef](docs/BarRef.md)
 - [BarRefOrValue](docs/BarRefOrValue.md)
 - [Entity](docs/Entity.md)
 - [EntityRef](docs/EntityRef.md)
 - [Extensible](docs/Extensible.md)
 - [Foo](docs/Foo.md)
 - [FooRef](docs/FooRef.md)
 - [FooRefOrValue](docs/FooRefOrValue.md)
 - [Fruit](docs/Fruit.md)
 - [FruitType](docs/FruitType.md)
 - [Pasta](docs/Pasta.md)
 - [Pizza](docs/Pizza.md)
 - [PizzaSpeziale](docs/PizzaSpeziale.md)


To get access to the crate's generated documentation, use:

```
cargo doc --open
```

## Author



