/*
 * OpenAPI Petstore
 *
 * This spec is mainly for testing Petstore server and contains fake endpoints, models. Please do not use this for any other purpose. Special characters: \" \\
 *
 * The version of the OpenAPI document: 1.0.0
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Org.OpenAPITools.Client.OpenAPIDateConverter;
using OpenAPIClientUtils = Org.OpenAPITools.Client.ClientUtils;

namespace Org.OpenAPITools.Model
{
    /// <summary>
    /// MixLog
    /// </summary>
    [DataContract(Name = "MixLog")]
    public partial class MixLog : IEquatable<MixLog>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="MixLog" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected MixLog()
        {
            this.AdditionalProperties = new Dictionary<string, object>();
        }
        /// <summary>
        /// Initializes a new instance of the <see cref="MixLog" /> class.
        /// </summary>
        /// <param name="id">id (required).</param>
        /// <param name="description">description (required).</param>
        /// <param name="mixDate">mixDate (required).</param>
        /// <param name="shopId">shopId.</param>
        /// <param name="totalPrice">totalPrice.</param>
        /// <param name="totalRecalculations">totalRecalculations (required).</param>
        /// <param name="totalOverPoors">totalOverPoors (required).</param>
        /// <param name="totalSkips">totalSkips (required).</param>
        /// <param name="totalUnderPours">totalUnderPours (required).</param>
        /// <param name="formulaVersionDate">formulaVersionDate (required).</param>
        /// <param name="someCode">SomeCode is only required for color mixes.</param>
        /// <param name="batchNumber">batchNumber.</param>
        /// <param name="brandCode">BrandCode is only required for non-color mixes.</param>
        /// <param name="brandId">BrandId is only required for color mixes.</param>
        /// <param name="brandName">BrandName is only required for color mixes.</param>
        /// <param name="categoryCode">CategoryCode is not used anymore.</param>
        /// <param name="color">Color is only required for color mixes.</param>
        /// <param name="colorDescription">colorDescription.</param>
        /// <param name="comment">comment.</param>
        /// <param name="commercialProductCode">commercialProductCode.</param>
        /// <param name="productLineCode">ProductLineCode is only required for color mixes.</param>
        /// <param name="country">country.</param>
        /// <param name="createdBy">createdBy.</param>
        /// <param name="createdByFirstName">createdByFirstName.</param>
        /// <param name="createdByLastName">createdByLastName.</param>
        /// <param name="deltaECalculationRepaired">deltaECalculationRepaired.</param>
        /// <param name="deltaECalculationSprayout">deltaECalculationSprayout.</param>
        /// <param name="ownColorVariantNumber">ownColorVariantNumber.</param>
        /// <param name="primerProductId">primerProductId.</param>
        /// <param name="productId">ProductId is only required for color mixes.</param>
        /// <param name="productName">ProductName is only required for color mixes.</param>
        /// <param name="selectedVersionIndex">selectedVersionIndex.</param>
        public MixLog(Guid id = default(Guid), string description = default(string), DateTime mixDate = default(DateTime), Guid shopId = default(Guid), float? totalPrice = default(float?), int totalRecalculations = default(int), int totalOverPoors = default(int), int totalSkips = default(int), int totalUnderPours = default(int), DateTime formulaVersionDate = default(DateTime), string someCode = default(string), string batchNumber = default(string), string brandCode = default(string), string brandId = default(string), string brandName = default(string), string categoryCode = default(string), string color = default(string), string colorDescription = default(string), string comment = default(string), string commercialProductCode = default(string), string productLineCode = default(string), string country = default(string), string createdBy = default(string), string createdByFirstName = default(string), string createdByLastName = default(string), string deltaECalculationRepaired = default(string), string deltaECalculationSprayout = default(string), int? ownColorVariantNumber = default(int?), string primerProductId = default(string), string productId = default(string), string productName = default(string), int selectedVersionIndex = default(int))
        {
            this._Id = id;
            // to ensure "description" is required (not null)
            if (description == null)
            {
                throw new ArgumentNullException("description is a required property for MixLog and cannot be null");
            }
            this._Description = description;
            this._MixDate = mixDate;
            this._TotalRecalculations = totalRecalculations;
            this._TotalOverPoors = totalOverPoors;
            this._TotalSkips = totalSkips;
            this._TotalUnderPours = totalUnderPours;
            this._FormulaVersionDate = formulaVersionDate;
            this._ShopId = shopId;
            if (this.ShopId != null)
            {
                this._flagShopId = true;
            }
            this._TotalPrice = totalPrice;
            if (this.TotalPrice != null)
            {
                this._flagTotalPrice = true;
            }
            this._SomeCode = someCode;
            if (this.SomeCode != null)
            {
                this._flagSomeCode = true;
            }
            this._BatchNumber = batchNumber;
            if (this.BatchNumber != null)
            {
                this._flagBatchNumber = true;
            }
            this._BrandCode = brandCode;
            if (this.BrandCode != null)
            {
                this._flagBrandCode = true;
            }
            this._BrandId = brandId;
            if (this.BrandId != null)
            {
                this._flagBrandId = true;
            }
            this._BrandName = brandName;
            if (this.BrandName != null)
            {
                this._flagBrandName = true;
            }
            this._CategoryCode = categoryCode;
            if (this.CategoryCode != null)
            {
                this._flagCategoryCode = true;
            }
            this._Color = color;
            if (this.Color != null)
            {
                this._flagColor = true;
            }
            this._ColorDescription = colorDescription;
            if (this.ColorDescription != null)
            {
                this._flagColorDescription = true;
            }
            this._Comment = comment;
            if (this.Comment != null)
            {
                this._flagComment = true;
            }
            this._CommercialProductCode = commercialProductCode;
            if (this.CommercialProductCode != null)
            {
                this._flagCommercialProductCode = true;
            }
            this._ProductLineCode = productLineCode;
            if (this.ProductLineCode != null)
            {
                this._flagProductLineCode = true;
            }
            this._Country = country;
            if (this.Country != null)
            {
                this._flagCountry = true;
            }
            this._CreatedBy = createdBy;
            if (this.CreatedBy != null)
            {
                this._flagCreatedBy = true;
            }
            this._CreatedByFirstName = createdByFirstName;
            if (this.CreatedByFirstName != null)
            {
                this._flagCreatedByFirstName = true;
            }
            this._CreatedByLastName = createdByLastName;
            if (this.CreatedByLastName != null)
            {
                this._flagCreatedByLastName = true;
            }
            this._DeltaECalculationRepaired = deltaECalculationRepaired;
            if (this.DeltaECalculationRepaired != null)
            {
                this._flagDeltaECalculationRepaired = true;
            }
            this._DeltaECalculationSprayout = deltaECalculationSprayout;
            if (this.DeltaECalculationSprayout != null)
            {
                this._flagDeltaECalculationSprayout = true;
            }
            this._OwnColorVariantNumber = ownColorVariantNumber;
            if (this.OwnColorVariantNumber != null)
            {
                this._flagOwnColorVariantNumber = true;
            }
            this._PrimerProductId = primerProductId;
            if (this.PrimerProductId != null)
            {
                this._flagPrimerProductId = true;
            }
            this._ProductId = productId;
            if (this.ProductId != null)
            {
                this._flagProductId = true;
            }
            this._ProductName = productName;
            if (this.ProductName != null)
            {
                this._flagProductName = true;
            }
            this._SelectedVersionIndex = selectedVersionIndex;
            if (this.SelectedVersionIndex != null)
            {
                this._flagSelectedVersionIndex = true;
            }
            this.AdditionalProperties = new Dictionary<string, object>();
        }

        /// <summary>
        /// Gets or Sets Id
        /// </summary>
        [DataMember(Name = "id", IsRequired = true, EmitDefaultValue = true)]
        public Guid Id
        {
            get{ return _Id;}
            set
            {
                _Id = value;
                _flagId = true;
            }
        }
        private Guid _Id;
        private bool _flagId;

        /// <summary>
        /// Returns false as Id should not be serialized given that it's read-only.
        /// </summary>
        /// <returns>false (boolean)</returns>
        public bool ShouldSerializeId()
        {
            return _flagId;
        }
        /// <summary>
        /// Gets or Sets Description
        /// </summary>
        [DataMember(Name = "description", IsRequired = true, EmitDefaultValue = true)]
        public string Description
        {
            get{ return _Description;}
            set
            {
                _Description = value;
                _flagDescription = true;
            }
        }
        private string _Description;
        private bool _flagDescription;

        /// <summary>
        /// Returns false as Description should not be serialized given that it's read-only.
        /// </summary>
        /// <returns>false (boolean)</returns>
        public bool ShouldSerializeDescription()
        {
            return _flagDescription;
        }
        /// <summary>
        /// Gets or Sets MixDate
        /// </summary>
        [DataMember(Name = "mixDate", IsRequired = true, EmitDefaultValue = true)]
        public DateTime MixDate
        {
            get{ return _MixDate;}
            set
            {
                _MixDate = value;
                _flagMixDate = true;
            }
        }
        private DateTime _MixDate;
        private bool _flagMixDate;

        /// <summary>
        /// Returns false as MixDate should not be serialized given that it's read-only.
        /// </summary>
        /// <returns>false (boolean)</returns>
        public bool ShouldSerializeMixDate()
        {
            return _flagMixDate;
        }
        /// <summary>
        /// Gets or Sets ShopId
        /// </summary>
        [DataMember(Name = "shopId", EmitDefaultValue = false)]
        public Guid ShopId
        {
            get{ return _ShopId;}
            set
            {
                _ShopId = value;
                _flagShopId = true;
            }
        }
        private Guid _ShopId;
        private bool _flagShopId;

        /// <summary>
        /// Returns false as ShopId should not be serialized given that it's read-only.
        /// </summary>
        /// <returns>false (boolean)</returns>
        public bool ShouldSerializeShopId()
        {
            return _flagShopId;
        }
        /// <summary>
        /// Gets or Sets TotalPrice
        /// </summary>
        [DataMember(Name = "totalPrice", EmitDefaultValue = true)]
        public float? TotalPrice
        {
            get{ return _TotalPrice;}
            set
            {
                _TotalPrice = value;
                _flagTotalPrice = true;
            }
        }
        private float? _TotalPrice;
        private bool _flagTotalPrice;

        /// <summary>
        /// Returns false as TotalPrice should not be serialized given that it's read-only.
        /// </summary>
        /// <returns>false (boolean)</returns>
        public bool ShouldSerializeTotalPrice()
        {
            return _flagTotalPrice;
        }
        /// <summary>
        /// Gets or Sets TotalRecalculations
        /// </summary>
        [DataMember(Name = "totalRecalculations", IsRequired = true, EmitDefaultValue = true)]
        public int TotalRecalculations
        {
            get{ return _TotalRecalculations;}
            set
            {
                _TotalRecalculations = value;
                _flagTotalRecalculations = true;
            }
        }
        private int _TotalRecalculations;
        private bool _flagTotalRecalculations;

        /// <summary>
        /// Returns false as TotalRecalculations should not be serialized given that it's read-only.
        /// </summary>
        /// <returns>false (boolean)</returns>
        public bool ShouldSerializeTotalRecalculations()
        {
            return _flagTotalRecalculations;
        }
        /// <summary>
        /// Gets or Sets TotalOverPoors
        /// </summary>
        [DataMember(Name = "totalOverPoors", IsRequired = true, EmitDefaultValue = true)]
        public int TotalOverPoors
        {
            get{ return _TotalOverPoors;}
            set
            {
                _TotalOverPoors = value;
                _flagTotalOverPoors = true;
            }
        }
        private int _TotalOverPoors;
        private bool _flagTotalOverPoors;

        /// <summary>
        /// Returns false as TotalOverPoors should not be serialized given that it's read-only.
        /// </summary>
        /// <returns>false (boolean)</returns>
        public bool ShouldSerializeTotalOverPoors()
        {
            return _flagTotalOverPoors;
        }
        /// <summary>
        /// Gets or Sets TotalSkips
        /// </summary>
        [DataMember(Name = "totalSkips", IsRequired = true, EmitDefaultValue = true)]
        public int TotalSkips
        {
            get{ return _TotalSkips;}
            set
            {
                _TotalSkips = value;
                _flagTotalSkips = true;
            }
        }
        private int _TotalSkips;
        private bool _flagTotalSkips;

        /// <summary>
        /// Returns false as TotalSkips should not be serialized given that it's read-only.
        /// </summary>
        /// <returns>false (boolean)</returns>
        public bool ShouldSerializeTotalSkips()
        {
            return _flagTotalSkips;
        }
        /// <summary>
        /// Gets or Sets TotalUnderPours
        /// </summary>
        [DataMember(Name = "totalUnderPours", IsRequired = true, EmitDefaultValue = true)]
        public int TotalUnderPours
        {
            get{ return _TotalUnderPours;}
            set
            {
                _TotalUnderPours = value;
                _flagTotalUnderPours = true;
            }
        }
        private int _TotalUnderPours;
        private bool _flagTotalUnderPours;

        /// <summary>
        /// Returns false as TotalUnderPours should not be serialized given that it's read-only.
        /// </summary>
        /// <returns>false (boolean)</returns>
        public bool ShouldSerializeTotalUnderPours()
        {
            return _flagTotalUnderPours;
        }
        /// <summary>
        /// Gets or Sets FormulaVersionDate
        /// </summary>
        [DataMember(Name = "formulaVersionDate", IsRequired = true, EmitDefaultValue = true)]
        public DateTime FormulaVersionDate
        {
            get{ return _FormulaVersionDate;}
            set
            {
                _FormulaVersionDate = value;
                _flagFormulaVersionDate = true;
            }
        }
        private DateTime _FormulaVersionDate;
        private bool _flagFormulaVersionDate;

        /// <summary>
        /// Returns false as FormulaVersionDate should not be serialized given that it's read-only.
        /// </summary>
        /// <returns>false (boolean)</returns>
        public bool ShouldSerializeFormulaVersionDate()
        {
            return _flagFormulaVersionDate;
        }
        /// <summary>
        /// SomeCode is only required for color mixes
        /// </summary>
        /// <value>SomeCode is only required for color mixes</value>
        [DataMember(Name = "someCode", EmitDefaultValue = true)]
        public string SomeCode
        {
            get{ return _SomeCode;}
            set
            {
                _SomeCode = value;
                _flagSomeCode = true;
            }
        }
        private string _SomeCode;
        private bool _flagSomeCode;

        /// <summary>
        /// Returns false as SomeCode should not be serialized given that it's read-only.
        /// </summary>
        /// <returns>false (boolean)</returns>
        public bool ShouldSerializeSomeCode()
        {
            return _flagSomeCode;
        }
        /// <summary>
        /// Gets or Sets BatchNumber
        /// </summary>
        [DataMember(Name = "batchNumber", EmitDefaultValue = false)]
        public string BatchNumber
        {
            get{ return _BatchNumber;}
            set
            {
                _BatchNumber = value;
                _flagBatchNumber = true;
            }
        }
        private string _BatchNumber;
        private bool _flagBatchNumber;

        /// <summary>
        /// Returns false as BatchNumber should not be serialized given that it's read-only.
        /// </summary>
        /// <returns>false (boolean)</returns>
        public bool ShouldSerializeBatchNumber()
        {
            return _flagBatchNumber;
        }
        /// <summary>
        /// BrandCode is only required for non-color mixes
        /// </summary>
        /// <value>BrandCode is only required for non-color mixes</value>
        [DataMember(Name = "brandCode", EmitDefaultValue = false)]
        public string BrandCode
        {
            get{ return _BrandCode;}
            set
            {
                _BrandCode = value;
                _flagBrandCode = true;
            }
        }
        private string _BrandCode;
        private bool _flagBrandCode;

        /// <summary>
        /// Returns false as BrandCode should not be serialized given that it's read-only.
        /// </summary>
        /// <returns>false (boolean)</returns>
        public bool ShouldSerializeBrandCode()
        {
            return _flagBrandCode;
        }
        /// <summary>
        /// BrandId is only required for color mixes
        /// </summary>
        /// <value>BrandId is only required for color mixes</value>
        [DataMember(Name = "brandId", EmitDefaultValue = false)]
        public string BrandId
        {
            get{ return _BrandId;}
            set
            {
                _BrandId = value;
                _flagBrandId = true;
            }
        }
        private string _BrandId;
        private bool _flagBrandId;

        /// <summary>
        /// Returns false as BrandId should not be serialized given that it's read-only.
        /// </summary>
        /// <returns>false (boolean)</returns>
        public bool ShouldSerializeBrandId()
        {
            return _flagBrandId;
        }
        /// <summary>
        /// BrandName is only required for color mixes
        /// </summary>
        /// <value>BrandName is only required for color mixes</value>
        [DataMember(Name = "brandName", EmitDefaultValue = false)]
        public string BrandName
        {
            get{ return _BrandName;}
            set
            {
                _BrandName = value;
                _flagBrandName = true;
            }
        }
        private string _BrandName;
        private bool _flagBrandName;

        /// <summary>
        /// Returns false as BrandName should not be serialized given that it's read-only.
        /// </summary>
        /// <returns>false (boolean)</returns>
        public bool ShouldSerializeBrandName()
        {
            return _flagBrandName;
        }
        /// <summary>
        /// CategoryCode is not used anymore
        /// </summary>
        /// <value>CategoryCode is not used anymore</value>
        [DataMember(Name = "categoryCode", EmitDefaultValue = false)]
        public string CategoryCode
        {
            get{ return _CategoryCode;}
            set
            {
                _CategoryCode = value;
                _flagCategoryCode = true;
            }
        }
        private string _CategoryCode;
        private bool _flagCategoryCode;

        /// <summary>
        /// Returns false as CategoryCode should not be serialized given that it's read-only.
        /// </summary>
        /// <returns>false (boolean)</returns>
        public bool ShouldSerializeCategoryCode()
        {
            return _flagCategoryCode;
        }
        /// <summary>
        /// Color is only required for color mixes
        /// </summary>
        /// <value>Color is only required for color mixes</value>
        [DataMember(Name = "color", EmitDefaultValue = false)]
        public string Color
        {
            get{ return _Color;}
            set
            {
                _Color = value;
                _flagColor = true;
            }
        }
        private string _Color;
        private bool _flagColor;

        /// <summary>
        /// Returns false as Color should not be serialized given that it's read-only.
        /// </summary>
        /// <returns>false (boolean)</returns>
        public bool ShouldSerializeColor()
        {
            return _flagColor;
        }
        /// <summary>
        /// Gets or Sets ColorDescription
        /// </summary>
        [DataMember(Name = "colorDescription", EmitDefaultValue = false)]
        public string ColorDescription
        {
            get{ return _ColorDescription;}
            set
            {
                _ColorDescription = value;
                _flagColorDescription = true;
            }
        }
        private string _ColorDescription;
        private bool _flagColorDescription;

        /// <summary>
        /// Returns false as ColorDescription should not be serialized given that it's read-only.
        /// </summary>
        /// <returns>false (boolean)</returns>
        public bool ShouldSerializeColorDescription()
        {
            return _flagColorDescription;
        }
        /// <summary>
        /// Gets or Sets Comment
        /// </summary>
        [DataMember(Name = "comment", EmitDefaultValue = false)]
        public string Comment
        {
            get{ return _Comment;}
            set
            {
                _Comment = value;
                _flagComment = true;
            }
        }
        private string _Comment;
        private bool _flagComment;

        /// <summary>
        /// Returns false as Comment should not be serialized given that it's read-only.
        /// </summary>
        /// <returns>false (boolean)</returns>
        public bool ShouldSerializeComment()
        {
            return _flagComment;
        }
        /// <summary>
        /// Gets or Sets CommercialProductCode
        /// </summary>
        [DataMember(Name = "commercialProductCode", EmitDefaultValue = false)]
        public string CommercialProductCode
        {
            get{ return _CommercialProductCode;}
            set
            {
                _CommercialProductCode = value;
                _flagCommercialProductCode = true;
            }
        }
        private string _CommercialProductCode;
        private bool _flagCommercialProductCode;

        /// <summary>
        /// Returns false as CommercialProductCode should not be serialized given that it's read-only.
        /// </summary>
        /// <returns>false (boolean)</returns>
        public bool ShouldSerializeCommercialProductCode()
        {
            return _flagCommercialProductCode;
        }
        /// <summary>
        /// ProductLineCode is only required for color mixes
        /// </summary>
        /// <value>ProductLineCode is only required for color mixes</value>
        [DataMember(Name = "productLineCode", EmitDefaultValue = false)]
        public string ProductLineCode
        {
            get{ return _ProductLineCode;}
            set
            {
                _ProductLineCode = value;
                _flagProductLineCode = true;
            }
        }
        private string _ProductLineCode;
        private bool _flagProductLineCode;

        /// <summary>
        /// Returns false as ProductLineCode should not be serialized given that it's read-only.
        /// </summary>
        /// <returns>false (boolean)</returns>
        public bool ShouldSerializeProductLineCode()
        {
            return _flagProductLineCode;
        }
        /// <summary>
        /// Gets or Sets Country
        /// </summary>
        [DataMember(Name = "country", EmitDefaultValue = false)]
        public string Country
        {
            get{ return _Country;}
            set
            {
                _Country = value;
                _flagCountry = true;
            }
        }
        private string _Country;
        private bool _flagCountry;

        /// <summary>
        /// Returns false as Country should not be serialized given that it's read-only.
        /// </summary>
        /// <returns>false (boolean)</returns>
        public bool ShouldSerializeCountry()
        {
            return _flagCountry;
        }
        /// <summary>
        /// Gets or Sets CreatedBy
        /// </summary>
        [DataMember(Name = "createdBy", EmitDefaultValue = false)]
        public string CreatedBy
        {
            get{ return _CreatedBy;}
            set
            {
                _CreatedBy = value;
                _flagCreatedBy = true;
            }
        }
        private string _CreatedBy;
        private bool _flagCreatedBy;

        /// <summary>
        /// Returns false as CreatedBy should not be serialized given that it's read-only.
        /// </summary>
        /// <returns>false (boolean)</returns>
        public bool ShouldSerializeCreatedBy()
        {
            return _flagCreatedBy;
        }
        /// <summary>
        /// Gets or Sets CreatedByFirstName
        /// </summary>
        [DataMember(Name = "createdByFirstName", EmitDefaultValue = false)]
        public string CreatedByFirstName
        {
            get{ return _CreatedByFirstName;}
            set
            {
                _CreatedByFirstName = value;
                _flagCreatedByFirstName = true;
            }
        }
        private string _CreatedByFirstName;
        private bool _flagCreatedByFirstName;

        /// <summary>
        /// Returns false as CreatedByFirstName should not be serialized given that it's read-only.
        /// </summary>
        /// <returns>false (boolean)</returns>
        public bool ShouldSerializeCreatedByFirstName()
        {
            return _flagCreatedByFirstName;
        }
        /// <summary>
        /// Gets or Sets CreatedByLastName
        /// </summary>
        [DataMember(Name = "createdByLastName", EmitDefaultValue = false)]
        public string CreatedByLastName
        {
            get{ return _CreatedByLastName;}
            set
            {
                _CreatedByLastName = value;
                _flagCreatedByLastName = true;
            }
        }
        private string _CreatedByLastName;
        private bool _flagCreatedByLastName;

        /// <summary>
        /// Returns false as CreatedByLastName should not be serialized given that it's read-only.
        /// </summary>
        /// <returns>false (boolean)</returns>
        public bool ShouldSerializeCreatedByLastName()
        {
            return _flagCreatedByLastName;
        }
        /// <summary>
        /// Gets or Sets DeltaECalculationRepaired
        /// </summary>
        [DataMember(Name = "deltaECalculationRepaired", EmitDefaultValue = false)]
        public string DeltaECalculationRepaired
        {
            get{ return _DeltaECalculationRepaired;}
            set
            {
                _DeltaECalculationRepaired = value;
                _flagDeltaECalculationRepaired = true;
            }
        }
        private string _DeltaECalculationRepaired;
        private bool _flagDeltaECalculationRepaired;

        /// <summary>
        /// Returns false as DeltaECalculationRepaired should not be serialized given that it's read-only.
        /// </summary>
        /// <returns>false (boolean)</returns>
        public bool ShouldSerializeDeltaECalculationRepaired()
        {
            return _flagDeltaECalculationRepaired;
        }
        /// <summary>
        /// Gets or Sets DeltaECalculationSprayout
        /// </summary>
        [DataMember(Name = "deltaECalculationSprayout", EmitDefaultValue = false)]
        public string DeltaECalculationSprayout
        {
            get{ return _DeltaECalculationSprayout;}
            set
            {
                _DeltaECalculationSprayout = value;
                _flagDeltaECalculationSprayout = true;
            }
        }
        private string _DeltaECalculationSprayout;
        private bool _flagDeltaECalculationSprayout;

        /// <summary>
        /// Returns false as DeltaECalculationSprayout should not be serialized given that it's read-only.
        /// </summary>
        /// <returns>false (boolean)</returns>
        public bool ShouldSerializeDeltaECalculationSprayout()
        {
            return _flagDeltaECalculationSprayout;
        }
        /// <summary>
        /// Gets or Sets OwnColorVariantNumber
        /// </summary>
        [DataMember(Name = "ownColorVariantNumber", EmitDefaultValue = true)]
        public int? OwnColorVariantNumber
        {
            get{ return _OwnColorVariantNumber;}
            set
            {
                _OwnColorVariantNumber = value;
                _flagOwnColorVariantNumber = true;
            }
        }
        private int? _OwnColorVariantNumber;
        private bool _flagOwnColorVariantNumber;

        /// <summary>
        /// Returns false as OwnColorVariantNumber should not be serialized given that it's read-only.
        /// </summary>
        /// <returns>false (boolean)</returns>
        public bool ShouldSerializeOwnColorVariantNumber()
        {
            return _flagOwnColorVariantNumber;
        }
        /// <summary>
        /// Gets or Sets PrimerProductId
        /// </summary>
        [DataMember(Name = "primerProductId", EmitDefaultValue = false)]
        public string PrimerProductId
        {
            get{ return _PrimerProductId;}
            set
            {
                _PrimerProductId = value;
                _flagPrimerProductId = true;
            }
        }
        private string _PrimerProductId;
        private bool _flagPrimerProductId;

        /// <summary>
        /// Returns false as PrimerProductId should not be serialized given that it's read-only.
        /// </summary>
        /// <returns>false (boolean)</returns>
        public bool ShouldSerializePrimerProductId()
        {
            return _flagPrimerProductId;
        }
        /// <summary>
        /// ProductId is only required for color mixes
        /// </summary>
        /// <value>ProductId is only required for color mixes</value>
        [DataMember(Name = "productId", EmitDefaultValue = false)]
        public string ProductId
        {
            get{ return _ProductId;}
            set
            {
                _ProductId = value;
                _flagProductId = true;
            }
        }
        private string _ProductId;
        private bool _flagProductId;

        /// <summary>
        /// Returns false as ProductId should not be serialized given that it's read-only.
        /// </summary>
        /// <returns>false (boolean)</returns>
        public bool ShouldSerializeProductId()
        {
            return _flagProductId;
        }
        /// <summary>
        /// ProductName is only required for color mixes
        /// </summary>
        /// <value>ProductName is only required for color mixes</value>
        [DataMember(Name = "productName", EmitDefaultValue = false)]
        public string ProductName
        {
            get{ return _ProductName;}
            set
            {
                _ProductName = value;
                _flagProductName = true;
            }
        }
        private string _ProductName;
        private bool _flagProductName;

        /// <summary>
        /// Returns false as ProductName should not be serialized given that it's read-only.
        /// </summary>
        /// <returns>false (boolean)</returns>
        public bool ShouldSerializeProductName()
        {
            return _flagProductName;
        }
        /// <summary>
        /// Gets or Sets SelectedVersionIndex
        /// </summary>
        [DataMember(Name = "selectedVersionIndex", EmitDefaultValue = false)]
        public int SelectedVersionIndex
        {
            get{ return _SelectedVersionIndex;}
            set
            {
                _SelectedVersionIndex = value;
                _flagSelectedVersionIndex = true;
            }
        }
        private int _SelectedVersionIndex;
        private bool _flagSelectedVersionIndex;

        /// <summary>
        /// Returns false as SelectedVersionIndex should not be serialized given that it's read-only.
        /// </summary>
        /// <returns>false (boolean)</returns>
        public bool ShouldSerializeSelectedVersionIndex()
        {
            return _flagSelectedVersionIndex;
        }
        /// <summary>
        /// Gets or Sets additional properties
        /// </summary>
        [JsonExtensionData]
        public IDictionary<string, object> AdditionalProperties { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class MixLog {\n");
            sb.Append("  Id: ").Append(Id).Append("\n");
            sb.Append("  Description: ").Append(Description).Append("\n");
            sb.Append("  MixDate: ").Append(MixDate).Append("\n");
            sb.Append("  ShopId: ").Append(ShopId).Append("\n");
            sb.Append("  TotalPrice: ").Append(TotalPrice).Append("\n");
            sb.Append("  TotalRecalculations: ").Append(TotalRecalculations).Append("\n");
            sb.Append("  TotalOverPoors: ").Append(TotalOverPoors).Append("\n");
            sb.Append("  TotalSkips: ").Append(TotalSkips).Append("\n");
            sb.Append("  TotalUnderPours: ").Append(TotalUnderPours).Append("\n");
            sb.Append("  FormulaVersionDate: ").Append(FormulaVersionDate).Append("\n");
            sb.Append("  SomeCode: ").Append(SomeCode).Append("\n");
            sb.Append("  BatchNumber: ").Append(BatchNumber).Append("\n");
            sb.Append("  BrandCode: ").Append(BrandCode).Append("\n");
            sb.Append("  BrandId: ").Append(BrandId).Append("\n");
            sb.Append("  BrandName: ").Append(BrandName).Append("\n");
            sb.Append("  CategoryCode: ").Append(CategoryCode).Append("\n");
            sb.Append("  Color: ").Append(Color).Append("\n");
            sb.Append("  ColorDescription: ").Append(ColorDescription).Append("\n");
            sb.Append("  Comment: ").Append(Comment).Append("\n");
            sb.Append("  CommercialProductCode: ").Append(CommercialProductCode).Append("\n");
            sb.Append("  ProductLineCode: ").Append(ProductLineCode).Append("\n");
            sb.Append("  Country: ").Append(Country).Append("\n");
            sb.Append("  CreatedBy: ").Append(CreatedBy).Append("\n");
            sb.Append("  CreatedByFirstName: ").Append(CreatedByFirstName).Append("\n");
            sb.Append("  CreatedByLastName: ").Append(CreatedByLastName).Append("\n");
            sb.Append("  DeltaECalculationRepaired: ").Append(DeltaECalculationRepaired).Append("\n");
            sb.Append("  DeltaECalculationSprayout: ").Append(DeltaECalculationSprayout).Append("\n");
            sb.Append("  OwnColorVariantNumber: ").Append(OwnColorVariantNumber).Append("\n");
            sb.Append("  PrimerProductId: ").Append(PrimerProductId).Append("\n");
            sb.Append("  ProductId: ").Append(ProductId).Append("\n");
            sb.Append("  ProductName: ").Append(ProductName).Append("\n");
            sb.Append("  SelectedVersionIndex: ").Append(SelectedVersionIndex).Append("\n");
            sb.Append("  AdditionalProperties: ").Append(AdditionalProperties).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return OpenAPIClientUtils.compareLogic.Compare(this, input as MixLog).AreEqual;
        }

        /// <summary>
        /// Returns true if MixLog instances are equal
        /// </summary>
        /// <param name="input">Instance of MixLog to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(MixLog input)
        {
            return OpenAPIClientUtils.compareLogic.Compare(this, input).AreEqual;
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Id != null)
                {
                    hashCode = (hashCode * 59) + this.Id.GetHashCode();
                }
                if (this.Description != null)
                {
                    hashCode = (hashCode * 59) + this.Description.GetHashCode();
                }
                if (this.MixDate != null)
                {
                    hashCode = (hashCode * 59) + this.MixDate.GetHashCode();
                }
                if (this.ShopId != null)
                {
                    hashCode = (hashCode * 59) + this.ShopId.GetHashCode();
                }
                if (this.TotalPrice != null)
                {
                    hashCode = (hashCode * 59) + this.TotalPrice.GetHashCode();
                }
                hashCode = (hashCode * 59) + this.TotalRecalculations.GetHashCode();
                hashCode = (hashCode * 59) + this.TotalOverPoors.GetHashCode();
                hashCode = (hashCode * 59) + this.TotalSkips.GetHashCode();
                hashCode = (hashCode * 59) + this.TotalUnderPours.GetHashCode();
                if (this.FormulaVersionDate != null)
                {
                    hashCode = (hashCode * 59) + this.FormulaVersionDate.GetHashCode();
                }
                if (this.SomeCode != null)
                {
                    hashCode = (hashCode * 59) + this.SomeCode.GetHashCode();
                }
                if (this.BatchNumber != null)
                {
                    hashCode = (hashCode * 59) + this.BatchNumber.GetHashCode();
                }
                if (this.BrandCode != null)
                {
                    hashCode = (hashCode * 59) + this.BrandCode.GetHashCode();
                }
                if (this.BrandId != null)
                {
                    hashCode = (hashCode * 59) + this.BrandId.GetHashCode();
                }
                if (this.BrandName != null)
                {
                    hashCode = (hashCode * 59) + this.BrandName.GetHashCode();
                }
                if (this.CategoryCode != null)
                {
                    hashCode = (hashCode * 59) + this.CategoryCode.GetHashCode();
                }
                if (this.Color != null)
                {
                    hashCode = (hashCode * 59) + this.Color.GetHashCode();
                }
                if (this.ColorDescription != null)
                {
                    hashCode = (hashCode * 59) + this.ColorDescription.GetHashCode();
                }
                if (this.Comment != null)
                {
                    hashCode = (hashCode * 59) + this.Comment.GetHashCode();
                }
                if (this.CommercialProductCode != null)
                {
                    hashCode = (hashCode * 59) + this.CommercialProductCode.GetHashCode();
                }
                if (this.ProductLineCode != null)
                {
                    hashCode = (hashCode * 59) + this.ProductLineCode.GetHashCode();
                }
                if (this.Country != null)
                {
                    hashCode = (hashCode * 59) + this.Country.GetHashCode();
                }
                if (this.CreatedBy != null)
                {
                    hashCode = (hashCode * 59) + this.CreatedBy.GetHashCode();
                }
                if (this.CreatedByFirstName != null)
                {
                    hashCode = (hashCode * 59) + this.CreatedByFirstName.GetHashCode();
                }
                if (this.CreatedByLastName != null)
                {
                    hashCode = (hashCode * 59) + this.CreatedByLastName.GetHashCode();
                }
                if (this.DeltaECalculationRepaired != null)
                {
                    hashCode = (hashCode * 59) + this.DeltaECalculationRepaired.GetHashCode();
                }
                if (this.DeltaECalculationSprayout != null)
                {
                    hashCode = (hashCode * 59) + this.DeltaECalculationSprayout.GetHashCode();
                }
                if (this.OwnColorVariantNumber != null)
                {
                    hashCode = (hashCode * 59) + this.OwnColorVariantNumber.GetHashCode();
                }
                if (this.PrimerProductId != null)
                {
                    hashCode = (hashCode * 59) + this.PrimerProductId.GetHashCode();
                }
                if (this.ProductId != null)
                {
                    hashCode = (hashCode * 59) + this.ProductId.GetHashCode();
                }
                if (this.ProductName != null)
                {
                    hashCode = (hashCode * 59) + this.ProductName.GetHashCode();
                }
                hashCode = (hashCode * 59) + this.SelectedVersionIndex.GetHashCode();
                if (this.AdditionalProperties != null)
                {
                    hashCode = (hashCode * 59) + this.AdditionalProperties.GetHashCode();
                }
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
