package org.openapitools.model

import java.util.Objects
import com.fasterxml.jackson.annotation.JsonValue
import com.fasterxml.jackson.annotation.JsonCreator
import com.fasterxml.jackson.annotation.JsonProperty
import jakarta.validation.constraints.DecimalMax
import jakarta.validation.constraints.DecimalMin
import jakarta.validation.constraints.Email
import jakarta.validation.constraints.Max
import jakarta.validation.constraints.Min
import jakarta.validation.constraints.NotNull
import jakarta.validation.constraints.Pattern
import jakarta.validation.constraints.Size
import jakarta.validation.Valid

/**
* 
* Values: _10,_20
*/
enum class ReasonCode(@get:JsonValue val value: kotlin.Int) {

    _10(10),
    _20(20);

    companion object {
        @JvmStatic
        @JsonCreator
        fun forValue(value: kotlin.Int): ReasonCode {
                return values().first{it -> it.value == value}
        }
    }
}

